const mongoose = require('mongoose');
const Schema = mongoose.Schema;
var ObjectIdSchema = Schema.ObjectId;
var ObjectId = mongoose.Types.ObjectId;

let usersSchema = new Schema({
  "address"         : String,
  "connecttype"     : String,
  "firstname"       : {type:String, default:  ''},
  "lastname"        : {type:String, default: ''},
  "phone"           : {type:Number, default: ''},
  "country"         : {type: String, default: ''},
  "username"        : {type:String, default: ''},
  "luck_value"      : {type:String, default: ''},
  "added_value"     : {type:String, default: ''},
  "protect_key"     : {type:String, default: ''},
  "status"          : { type: Number, default: 0 },
  "secretkey"       : { type: Array},
  "user_type"       : { type: String},
  "created_at"      : { type: Date, default: Date.now },
  "updated_at"      : { type: Date, default: Date.now },
  "ip_address"      : { type:String, default: '' },
  "timezone"        : { type:String, default: '' },
  "type"            : { type:String, default: 'market' },
  "tfa_status"      : { type: Number, default: 0 },
  "ref_status"      : { type: Number, default: 1},
  "referr_id"       : { type: String, default: '' },
  "kyc_status"      : { type: Number, default: 0 },
  "id_status"       : { type: Number, default: 0 },
  "passport_status" : { type: Number, default: 0 },
  "residence_status": { type: Number, default: 0 },
  "selfie_status"   :  { type: Number, default: 0 },
  "profile_status"  :  { type: Number, default: 0 },
  "id_proof"        : { type: String, default: '' },
  "id_proof1"       : { type: String, default: '' },
  "passport_proof"  : { type: String, default: '' },
  "selfie_proof"    : { type: String, default: '' },
  "residence_proof" : { type: String, default: '' },
  "forgot_code"     : String,
  "gender"          : String,
  "DOB"             : Date,
  "address"         : String,
  "zip_code"        : Number,
  "city"            : String,
  "referrer_id"     : String,
  "tfa_code"        : String,
  "tfa_url"         : String,
  "withdraw_otp"    : String,
  "id_reject"       : String,
  "passport__reject": String,
  "residence_reject": String,
  "selfie_reject"   : String,
  "user_favourites" : { type: Array},
  "liked_game"      : { type: Array},
  "gamecount"       : { type: Array},
}, {"versionKey" : false});

module.exports = mongoose.model('user_info', usersSchema, 'user_info');